const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const project_collaborations = sequelize.define(
    'project_collaborations',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

permission_level: {
        type: DataTypes.ENUM,
      
      

        values: [

"view",


"comment",


"edit",


"admin"

        ],

      },

invited_at: {
        type: DataTypes.DATE,
      
      

      },

accepted_at: {
        type: DataTypes.DATE,
      
      

      },

invite_status: {
        type: DataTypes.ENUM,
      
      

        values: [

"pending",


"accepted",


"declined",


"revoked"

        ],

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  project_collaborations.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





























//end loop



    db.project_collaborations.belongsTo(db.projects, {
      as: 'project',
      foreignKey: {
        name: 'projectId',
      },
      constraints: false,
    });

    db.project_collaborations.belongsTo(db.users, {
      as: 'collaborator_user',
      foreignKey: {
        name: 'collaborator_userId',
      },
      constraints: false,
    });

    db.project_collaborations.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.project_collaborations.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.project_collaborations.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return project_collaborations;
};


